# RUNBOOK - Master Broken

These directions are supplemental technical steps to the guidelines at [master broken](https://about.gitlab.com/handbook/engineering/workflow/#triage-broken-master)

[[_TOC_]]

## Why

Timely broken master resolution is critical to minimize impact that deterministic and far reaching failures have on the productivity of GitLab teams. When `master` is red, merge request pipelines will fail due to [merged results pipelines](https://docs.gitlab.com/ee/ci/pipelines/merged_results_pipelines.html#merged-results-pipelines) on the `gitlab-org/gitlab` project.

Engineering Productivity is the DRI to identify why a broken master is occurring and so overall productivity is not impeded through failing MR pipelines. This responsibility is reflected in the [Pipeline Stability KPI](https://about.gitlab.com/handbook/engineering/quality/performance-indicators/#master-pipeline-stability)

## What

Engineering Productivity identifies a broken master and creates an issue for the failure and identifies a DRI to resolve. The specific steps are documented in [this process](https://about.gitlab.com/handbook/engineering/workflow/#triage-broken-master).

Local recreation after initial identification helps the resolution DRI resolve. Local recreation is helpful in ensuring that fixes address the issue that is happening in CI.

## Expectations

### Identifying a DRI

In most cases, a revert is the fastest way to restore master stability. In these cases, the EP team member can [open a revert](https://docs.gitlab.com/ee/user/project/merge_requests/revert_changes.html#revert-a-merge-request) of a problematic MR and seek a frontend or backend maintainer review depending on what was needed in the original MR.

In some cases you may need to fix forward and ask for help based on the team or domain from the problem. Here are some examples:

- <https://gitlab.com/gitlab-org/gitlab/-/issues/345827>
- <https://gitlab.com/gitlab-org/gitlab/-/issues/362569>


### Identifying what alerts to act on

The most important Slack notifications to act on would follow this priority list:

- Failures that would be causing Merge Result pipelines in MRs to fail
  - This excludes any `RUBY3` pipeline or child `e2e:package-and-test` job which are allowed to fail in MRs.
- Consecutive notifications for different pipelines with the same failed jobs.
- GitLab-Foss failures for rspec and jest related jobs

It is not expected that failures on Saturday and Sunday are monitored and acted on by Engineering Productivity. These alerts will be generated by scheduled pipelines that run every 2 hours.

#### Alert overview

The current master broken notifications can be unclear initially. These should be improved upon with <https://gitlab.com/gitlab-org/quality/engineering-productivity/team/-/work_items/115987928> and this description should help until that point.

1. User that triggered the pipeline - this is normally the maintainer or bot user that triggered a scheduled pipeline.
1. Pipeline ID and duration - this is a link to the pipeline that triggered the notification. This can be used as a clue for multiple notifications on the same commit for child pipelines in the project.
1. Branch - which branch is trigering the notification. This can help identify if master or a stable branch is causing the failure.
1. Project and date - Shows the project (GitLab or GitLab Foss) and the date of the notification
1. Failed jobs - this links to all failed jobs and will list allowed failure jobs as well.

![master-broken-notification.png](assets/master-broken-slack.png)

## Common Issues

### Merge Order

Some merge requests fail because they are merged around the time of other MRs that cause problems. This happens most frequently with Rubocop, eslint and docs linters.

Actions:

- Applying linting correction or fix error
- Revert offending MR

Examples:

- <https://gitlab.com/gitlab-org/gitlab/-/issues/360915>
- <https://gitlab.com/gitlab-org/gitlab/-/issues/357641>
- <https://gitlab.com/gitlab-org/gitlab/-/issues/347143>


### Test side effects

This usually is the result of order dependent side effects from tests run together with knapsack.

Action:

1. [Recreate failure locally using rspec bisect](https://docs.gitlab.com/ee/development/testing_guide/flaky_tests.html#order-dependent-flaky-tests) to find the combination.
1. Failing test has the [~"quarantined test" label applied in the tracking issue](https://gitlab.com/gitlab-org/gitlab/-/issues/349762#note_dedb1ba24eeded00778f4a64b7a1c50dc444a0cb).
    - If proceeding with a quarantine of the test, follow the [Guide for Quarantined tests](https://docs.gitlab.com/ee/development/testing_guide/flaky_tests.html#quarantined-tests).
    - Example of the MR to quarantine a spec: https://gitlab.com/gitlab-org/gitlab/-/merge_requests/88254
1. Mention a [team EM or DRI](https://about.gitlab.com/handbook/product/categories/#dev-section) related to the spec area.
    - Features owned by each group can be found at [Features by Group](https://about.gitlab.com/handbook/product/categories/features/#manageauthentication-&-authorization-group).

Examples:

- https://gitlab.com/gitlab-org/gitlab/-/issues/331170#note_577480178
- https://gitlab.com/gitlab-org/gitlab/-/issues/343869

### GitLab.com reliability

Runner infrastructure or GitLab.com connectivity can lead to production incidents which cause failures in master.

Build failures that have 500, 503 or problems retrieving build images are likely underlying reliability issues

Actions:

- Check #incident-management for any current issues
- If none, search in Slack for similar reports and a potential issue created
- If still none, lucky you get to askin #production and create an issue to start tracking the failures.

Examples:

- <https://gitlab.com/gitlab-com/gl-infra/production/-/issues/7084>
- <https://gitlab.com/gitlab-com/gl-infra/production/-/issues/7258>

### GitLab Foss Broken Master

There are some failures that happen in the [`gitlab-foss`](https://gitlab.com/gitlab-org/gitlab-foss/) code base. Some rspec foss specs are executed in the `rspec-foss-impact` job based on the change but failures will happen for `jest` specs.

Why: Changes to BE/FE code in the `ee/` directory will be used for specs outside of the `ee/` directory in `gitlab-org/gitlab` pipelines but that code is not available in `gitlab-foss`. This will lead commonly lead to missing reference failures.

Actions:

1. Identification of notification for `gitlab-foss` project in `#master-broken`.
1. Create an issue to track
1. Recreate locally by running specs/processes with `FOSS_ONLY=1` prior to the command as [the `as-if-foss` jobs](https://docs.gitlab.com/ee/development/pipelines.html#as-if-foss-jobs).

Examples:

- <https://gitlab.com/gitlab-org/gitlab/-/issues/365500>
- <https://gitlab.com/gitlab-org/gitlab/-/issues/365492>

### Review QA Failures

`review-qa-smoke` and `review-qa-reliable` jobs are executed on scheduled master pipelines and may cause blocking failures in merge request pipelines. These failures should be investigated by SETs. In the case of <https://gitlab.com/gitlab-org/gitlab/-/merge_requests/90725> test cases were removed from reliable tests to be investigated why they failed to find runners.

Actions:

1. Search for any issues relating to the failure in `gitlab-org/gitlab`. For example <https://gitlab.com/gitlab-org/gitlab/-/issues/?search=browser_ui%2F13_secure%2Fvulnerability_management_spec.rb&sort=created_date&state=opened&first_page_size=20>
1. If there's no issue, ask SETs about failures in #quality channel
1. Ask the SETs to take quick action to fix or remove from smoke/reliable test sets to restore master stability

### Review Deploy Failures

`review-deploy` job is executed on scheduled master pipelines and the failure may cause blocking the merge of between [60% and 70% merge requests](https://app.periscopedata.com/app/gitlab/564156/EP---Pipelines-health?widget=8824008&udv=895971) (QA + Frontend changes).

Actions:

1. Find the name(s) of Pods that are failing to start in the [Pods](https://gitlab.com/gitlab-org/gitlab/-/jobs/2850376723#L158) section of the job log
1. Go to Google Cloud Project [gitlab-review-apps](https://console.cloud.google.com/welcome?project=gitlab-review-apps)
1. Navigate to the Logs Explorer by typing `Logging` in the search bar of the project
1. Define _severity_ and _pod_name_ like below in Query pane, then Run query

    ```
    severity="ERROR"
    resource.labels.pod_name="review-mastermain-mk1cr0-webservice-default-7f5485c57-9pc9b"
    ```

1. Find the root cause of the error in the pods by viewing the log entries that match with your query expressions in Query results pane

Examples:
- Sidekiq and Webservice Pods are failed to start since they are stuck in
[Init:CrashLoopBackOff](https://gitlab.com/gitlab-org/gitlab/-/jobs/2850376723#L177) error

## Failure recreation

### Jest failures that validate fixtures

Jest failures like [this one](https://gitlab.com/gitlab-org/gitlab/-/issues/375620) may require frontend fixtures to run the tests locally. You can generate all of them or selectively generate depending on if you can find what fixture is needed.

You can look at a jest spec to see a fixture being loaded to identify what fixture spec is generating it like [this example](https://gitlab.com/gitlab-org/gitlab/-/blob/6d732eade1a4deb0b5833ee847422d2a3bcb327a/spec/frontend/ci_variable_list/ci_variable_list/ci_variable_list_spec.js#L14) using `pipeline_schedules/edit.html`.

You can [selectively locally generate fixtures](https://docs.gitlab.com/ee/development/testing_guide/frontend_testing.html#generate-fixtures) with `bin/rspec <filename>` like `bin/rspec spec/frontend/fixtures/pipeline_schedules.rb` using the example above.

After generating fixtures you can run the jest spec with `yarn run jest spec/frontend/ci_variable_list/ci_variable_list/ci_variable_list_spec.js`.

### Download frontend assets from CI to reproduce feature spec failures locally

Sometimes we must reproduce test failures with the exact copy of the frontend assets generated in the pipeline, especially if assets caching plays a part in the root cause, such as [this incident](https://gitlab.com/gitlab-org/gitlab/-/issues/379000). You can follow these steps in such scenario:

- download and unzip artifacts from the `compile-test-assets` or `compile-test-assets-as-if-foss` jobs from the failing pipeline
1. Download and unzip artifacts from the `compile-test-assets` or `compile-test-assets-as-if-foss` jobs from the failing pipeline.
1. Copy `public/assets` from the downloaded artifact to `~/<path-to-gitlab-repo>/public`

```bash
# Copy `public/assets` to `public` directory in local `gitlab` project
cp -r public/assets ~/<path-to-gitlab>/public
```

1. Disable webpack-dev-server in `~/<path-to-gitlab-repo>/config/gitlab.yml`.

```yml
## Webpack settings
webpack:
  dev_server:
    enabled: false

## TIP: Some of us have seen duplicated webpack settings in gitlab.yml, 
## so do a search to make sure you only have this one setting before proceeding!
```

1. Restart GDK via

```bash
gdk restart
```

### Flaky failure

For the purpose of this doc, we are defining a flaky test failure as a failure that happens in CI but is not able to be reproduced locally.

These generally result from test side effects from the Knapsack testing set run in CI. They can generally be recreated by:

1. Identify the tests executed in the build by copying out the [Knapsack node specs](https://gitlab.com/gitlab-org/gitlab/-/jobs/2602700708#L243) section of the job log.
1. Find the specs(s) that are failing in the list and run all specs prior to and including the failing spec(s) locally against GDK.
1. Use [rspec bisect](https://relishapp.com/rspec/rspec-core/docs/command-line/bisect) to isolate the minimal failure combination of specs.

### Capybara ui inconsistency

`rspec system` failures are sometimes just flaky due to environment slowness and are hard to recreate locally. Sometimes they can locally be recreated by running the test multiple times like `repeat 20 { bundle exec rspec <spec> }` with a zsh shell.

## Known failure reasons

### Dependency proxy error

Build images that are cached by the dependency proxy are not available to be retrieved by project bots. There are some bots that auto-merge MRs and trigger pipelines such as `release-tools approver bot (project_278964_bot6)`.

Image retrieval in the CI Builds will fail with `ERROR: Job failed: failed to pull image "gitlab.com:443/gitlab-org/dependency_proxy/containers/ruby:2.7" with specified policies [always]: Error response from daemon: unauthorized: authentication required (manager.go:203:0s)`.

Fixed by <https://gitlab.com/gitlab-org/gitlab/-/issues/332411>

![dependency-proxy-error.png](assets/dependency-proxy-error.png)

### "No Space Left on Device"

Pipeline failures can occur when a job has utilized all runner disk space. When encountering these issues, proceed with the following steps:

1. Make sure to label the incident with ~"master-broken::runner-disk-full" as we are keeping track of these occurences as a first iteration for monitoring disk space utilization status. See https://gitlab.com/gitlab-org/quality/engineering-productivity/team/-/issues/132#note_1228200453 for explanation on why disk utilization metric is currently hard to be exported from the runners.
1. If this is a one-off occurrence, retry is a quick remediation step and works in most cases.
1. Create an issue to keep track of the occurrences if this failure happens frequently.
1. If there was a recent change to our CI jobs that is starting to increase the size of artifacts being generated, we should revert that MR as a quick fix while allowing us time to assess the next steps.
1. If an increase to the disk space is needed, reach out to the [Verify:Runner SaaS group](https://about.gitlab.com/handbook/product/categories/features/#verifyrunner-saas-group) and propose a change to the disk space similar to https://gitlab.com/gitlab-com/gl-infra/chef-repo/-/merge_requests/2587. Start a dicussion thread in `#infrastructure-lounge` if immediate attention is needed.
1. Runners can be reused up to 40 times so storage might be accumulated with files from older builds. If this has become a problem, one more option is to reduce the number of times runners are being reused by changing the [`MaxBuild` param](https://gitlab.com/gitlab-com/gl-infra/chef-repo/-/blob/bd9b9aa4544a9caddded19b08ada540923d36529/roles/runners-manager-private.json#L54). However, reducing runner reusage may cause delays in starting new pipelines because it requires more runners to spin up from scratch, so this option should be treated as the last resort.
